%global srcname pegasus
%global major_ver %%(echo %{version} | cut -d. -f1-2)
%ifarch x86_64
%global PEGASUS_HARDWARE_PLATFORM LINUX_X86_64_GNU
%endif
%ifarch ppc64le
%global PEGASUS_HARDWARE_PLATFORM LINUX_PPC64_GNU
%endif
%ifarch aarch64
%global PEGASUS_HARDWARE_PLATFORM LINUX_AARCH64_GNU
%endif
%ifarch loongarch64
%global PEGASUS_HARDWARE_PLATFORM LINUX_LOONGARCH64_GNU
%endif

%global PEGASUS_ARCH_LIB %{_lib}
%global OPENSSL_HOME %{_prefix}
%global OPENSSL_BIN %{_bindir}
%global PEGASUS_PEM_DIR %{_sysconfdir}/pki/Pegasus
%global PEGASUS_SSL_CERT_FILE server.pem
%global PEGASUS_SSL_KEY_FILE file.pem
%global PEGASUS_SSL_TRUSTSTORE client.pem
%global PAM_CONFIG_DIR %{_sysconfdir}/pam.d
%global PEGASUS_CONFIG_DIR %{_sysconfdir}/Pegasus
%global PEGASUS_VARDATA_DIR /var/lib/Pegasus
%global PEGASUS_VARDATA_CACHE_DIR /var/lib/Pegasus/cache
%global PEGASUS_LOCAL_DOMAIN_SOCKET_PATH  /var/run/tog-pegasus/socket/cimxml.socket
%global PEGASUS_CIMSERVER_START_FILE /var/run/tog-pegasus/cimserver.pid
%global PEGASUS_TRACE_FILE_PATH /var/lib/Pegasus/cache/trace/cimserver.trc
%global PEGASUS_CIMSERVER_START_LOCK_FILE /var/run/tog-pegasus/cimserver_start.lock
%global PEGASUS_REPOSITORY_DIR /var/lib/Pegasus/repository
%global PEGASUS_PREV_REPOSITORY_DIR_NAME prev_repository
%global PEGASUS_REPOSITORY_PARENT_DIR /var/lib/Pegasus
%global PEGASUS_PREV_REPOSITORY_DIR /var/lib/PegasusXXX/prev_repository
%global PEGASUS_SBIN_DIR %{_sbindir}
%global PEGASUS_DOC_DIR %{_defaultdocdir}/%{name}-%{version}

%global PEGASUS_RPM_ROOT $RPM_BUILD_DIR/%{srcname}
%global PEGASUS_RPM_HOME %PEGASUS_RPM_ROOT/build
%global PEGASUS_INSTALL_LOG /var/lib/Pegasus/log/install.log

Summary:      OpenPegasus WBEM Services for Linux
Name:         tog-pegasus
Version:      2.14.1
Release:      6%{?dist}
License:      MIT
URL:          http://www.openpegasus.org
Source0:      https://collaboration.opengroup.org/pegasus/documents/32572/pegasus-%{version}.tar.gz
Source1:      https://www.dmtf.org/sites/default/files/cim/cim_schema_v2380/cim_schema_2.38.0Experimental-MOFs.zip
Source2:      tog-pegasus.service
Source3:      access.conf
Source4:      tog-pegasus.tmpfiles
Source5:      generate-certs
Source6:      snmptrapd.conf
Source7:      repupgrade.1.gz
Source8:      tog-pegasus.sysusers

Patch3000:    pegasus-2.9.0-no-rpath.patch
Patch3001:    pegasus-2.7.0-PIE.patch
Patch3002:    pegasus-2.9.0-redhat-config.patch
Patch3003:    pegasus-2.9.0-cmpi-provider-lib.patch
Patch3004:    pegasus-2.5.1-pam-wbem.patch
Patch3005:    pegasus-2.7.0-snmp-tests.patch
Patch3006:    pegasus-2.9.0-local-or-remote-auth.patch
Patch3007:    pegasus-2.9.0-sparc.patch
Patch3008:    pegasus-2.9.1-getpagesize.patch
Patch3009:    pegasus-2.10.0-dont-strip.patch
Patch3010:    pegasus-2.10.0-sparc-posix-lock.patch
Patch3011:    pegasus-2.12.0-null_value.patch
Patch3012:    pegasus-2.12.0-empty_arrays.patch
Patch3013:    pegasus-2.12.0-cimmofl-allow-experimental.patch
Patch3014:    pegasus-2.12.0-schema-version-and-includes.patch
Patch3015:    pegasus-2.13.0-enable-subscriptions-for-nonprivileged-users.patch
Patch3016:    pegasus-2.13.0-gcc5-build.patch
Patch3017:    pegasus-2.14.1-build-fixes.patch
Patch3018:    pegasus-2.14.1-ssl-include.patch
Patch3019:    pegasus-2.14.1-snmpv3-trap.patch
Patch3020:    pegasus-2.14.1-fix-setup-sdk.patch
Patch3021:    pegasus-2.14.1-cimconfig-man-page-fixes.patch
Patch3022:    pegasus-2.14.1-fix-setup-sdk-ppc64le.patch
Patch3023:    pegasus-2.14.1-tesid.patch
Patch3024:    pegasus-2.14.1-ssl-cert-path.patch
Patch3025:    pegasus-2.14.1-openssl-1.1-fix.patch
Patch3026:    pegasus-2.14.1-fix-Wreserved-user-defined-literal.patch
Patch3027:    pegasus-2.14.1-crypto-policy-compliance.patch
Patch3028:    pegasus-2.14.1-add-pegwsmserver-to-ldd-libs.patch
Patch3029:    pegasus-2.14.1-build-fixes-2.patch
Patch3030:    pegasus-2.14.1-snmp-disable-des.patch
Patch3031:    0001-pegasus-add-loongarch64-support.patch

BuildRequires: procps libstdc++ pam-devel openssl openssl-devel bash sed grep coreutils procps gcc gcc-c++
BuildRequires: libstdc++ make pam-devel openssl-devel net-snmp-devel openslp-devel systemd-units systemd-rpm-macros
Requires:       %{name}-libs = %{version}-%{release} net-snmp-libs openssl ca-certificates
Requires(post): /sbin/restorecon
Provides:       cim-server = 1

%description
OpenPegasus WBEM Services for Linux enables management solutions that deliver increased control of
enterprise resources. WBEM is a platform and resource independent DMTF standard that defines a
common information model and communication protocol for monitoring and controlling resources from
diverse sources.

%package devel
Summary:        The OpenPegasus Software Development Kit
Requires:       tog-pegasus >= %{version}-%{release}

%description devel
The OpenPegasus WBEM Services for Linux SDK is the developer's kit for the OpenPegasus WBEM Services
for Linux release. It provides Linux C++ developers with the WBEM files required to build WBEM
Clients and Providers. It also supports C provider developers via the CMPI interface.

%package libs
Summary:        The OpenPegasus Libraries
Requires(pre):  /usr/sbin/useradd
Requires(pre):  /usr/sbin/groupadd
Conflicts:      libcmpiCppImpl0

%description libs
The OpenPegasus libraries.

%package test
Summary:        The OpenPegasus Tests
Requires:       tog-pegasus >= %{version}-%{release}, make
Requires:       %{name}-libs = %{version}-%{release}

%description test
The OpenPegasus WBEM tests for the OpenPegasus %{version} Linux rpm.

%prep
%setup -q -n %{srcname}
export PEGASUS_ROOT=%PEGASUS_RPM_ROOT
yes | mak/CreateDmtfSchema 238 %{SOURCE1} cim_schema_2.38.0
%autopatch -p1 -m 3000 -M 3031

%build
cp -fp %{SOURCE3} rpm
export PEGASUS_ROOT=%PEGASUS_RPM_ROOT
export PEGASUS_HOME=%PEGASUS_RPM_HOME
export PEGASUS_PLATFORM=%PEGASUS_HARDWARE_PLATFORM
export PEGASUS_ARCH_LIB=%PEGASUS_ARCH_LIB
export PEGASUS_ENVVAR_FILE=$PEGASUS_ROOT/env_var_Linux.status

export OPENSSL_HOME=%OPENSSL_HOME
export OPENSSL_BIN=%OPENSSL_BIN
export LD_LIBRARY_PATH=$PEGASUS_HOME/lib
export PATH=$PEGASUS_HOME/bin:$PATH

export PEGASUS_EXTRA_C_FLAGS="$RPM_OPT_FLAGS -fPIC -g -Wall -Wno-unused -fno-strict-aliasing"
export PEGASUS_EXTRA_CXX_FLAGS="$PEGASUS_EXTRA_C_FLAGS -std=c++14"
export PEGASUS_EXTRA_LINK_FLAGS="$RPM_OPT_FLAGS -Wl,-z,now"
export PEGASUS_EXTRA_PROGRAM_LINK_FLAGS="-g -pie -Wl,-z,relro,-z,now,-z,nodlopen,-z,noexecstack"
export SYS_INCLUDES=-I/usr/kerberos/include

%make_build -f ${PEGASUS_ROOT}/Makefile.Release create_ProductVersionFile
%make_build -f ${PEGASUS_ROOT}/Makefile.Release create_CommonProductDirectoriesInclude
%make_build -f ${PEGASUS_ROOT}/Makefile.Release create_ConfigProductDirectoriesInclude
%make_build -f ${PEGASUS_ROOT}/Makefile.Release all
%make_build -f ${PEGASUS_ROOT}/Makefile.Release repository


%install
mkdir -p %{buildroot}%{_sysconfdir}/pki/Pegasus

export PEGASUS_ROOT=%PEGASUS_RPM_ROOT
export PEGASUS_HOME=%PEGASUS_RPM_HOME
export PEGASUS_PLATFORM=%PEGASUS_HARDWARE_PLATFORM
export PEGASUS_ARCH_LIB=%PEGASUS_ARCH_LIB
export PEGASUS_ENVVAR_FILE=$PEGASUS_ROOT/env_var_Linux.status

export OPENSSL_BIN=%OPENSSL_BIN
export LD_LIBRARY_PATH=$PEGASUS_HOME/lib
export PATH=$PEGASUS_HOME/bin:$PATH

export PEGASUS_STAGING_DIR=%{buildroot}
make -f $PEGASUS_ROOT/Makefile.Release stage \
    PEGASUS_STAGING_DIR=$PEGASUS_STAGING_DIR \
    PEGASUS_BUILD_TEST_RPM=%{PEGASUS_BUILD_TEST_RPM}

install -p -Dm 644 %{SOURCE4} %{buildroot}/%{_tmpfilesdir}/tog-pegasus.conf
install -p -Dm 755 %{SOURCE5} %{buildroot}%{_datadir}/Pegasus/scripts/generate-certs

rm -f %{buildroot}%{_sysconfdir}/Pegasus/ssl.cnf
mkdir -p %{buildroot}%{_sysconfdir}/pki/Pegasus/crl

rm -f %{buildroot}%{_sysconfdir}/init.d/tog-pegasus

install -p -Dm 644 %{SOURCE2} %{buildroot}%{_unitdir}/tog-pegasus.service

mkdir -p %{buildroot}/%{_docdir}/%{name}
mv %{buildroot}%{_defaultdocdir}/%{name}-%{major_ver}/* %{buildroot}%{_docdir}/%{name}

rm -rf %{buildroot}%{_defaultdocdir}/%{name}-%{major_ver}
pushd %{buildroot}/usr/%{_lib}
ln -s libcmpiCppImpl.so.1 libcmpiCppImpl.so
ln -s libpeglistener.so.1 libpeglistener.so
popd

install -Dp %{buildroot}%{_sbindir}/cimprovagt %{buildroot}%{_libexecdir}/pegasus/cimprovagt
install -m 644 src/Pegasus/Common/Platform_LINUX_XSCALE_GNU.h %{buildroot}%{_includedir}/Pegasus/Common

install -Dm 644 src/Pegasus/Listener/Linkage.h %{buildroot}%{_includedir}/Pegasus/Listener
install -m 644 src/Pegasus/Listener/CIMListener.h %{buildroot}%{_includedir}/Pegasus/Listener
install -m 644 src/Pegasus/Client/CIMEnumerationContext.h %{buildroot}%{_includedir}/Pegasus/Client
install -m 644 src/Pegasus/Common/UintArgs.h %{buildroot}%{_includedir}/Pegasus/Common

install -p %{SOURCE6} %{buildroot}%{_datadir}/Pegasus/test/snmptrapd.conf

install -p Schemas/CIM238/DMTF/Core/CIM_AbstractComponent.mof \
    %{buildroot}%{_datadir}/Pegasus/samples/Providers/Load/CIM238/DMTF/Core/

install -D %{SOURCE7} %{buildroot}/%{_mandir}/man1/repupgrade.1.gz

install -p -D -m 0644 %{SOURCE8} %{buildroot}%{_sysusersdir}/tog-pegasus.conf

# do not support this type
rm -f %{buildroot}%{_defaultdocdir}/%{name}/SecurityGuidelinesForDevelopers.html
rm -f %{buildroot}%{_defaultdocdir}/%{name}/PegasusSSLGuidelines.htm

%check
export LD_LIBRARY_PATH=%{buildroot}/usr/%{_lib}
cd %{buildroot}%{_datadir}/Pegasus/test
make prestarttests
rm %{buildroot}%{_datadir}/Pegasus/test/log.trace.0
rm %{buildroot}%{_datadir}/Pegasus/test/testtracer4.trace.0

%pre
if [ $1 -gt 1 ]; then
   if [ -d /var/lib/Pegasus/repository ]; then
        if [ -d /var/lib/Pegasus/prev_repository ]; then
           rm -rf /var/lib/Pegasus/prev_repository
        fi;
        cp -r /var/lib/Pegasus/repository /var/lib/Pegasus/prev_repository;
   fi
fi
:;

%post
install -d -m 1750 -o root -g pegasus /var/run/tog-pegasus
restorecon /var/run/tog-pegasus
%systemd_post tog-pegasus.service
if [ $1 -ge 1 ]; then
   echo `date` >>  /var/lib/Pegasus/log/install.log 2>&1 || :;
   if [ $1 -gt 1 ]; then
      if [ -d /var/lib/Pegasus/prev_repository ]; then
         /usr/sbin/repupgrade 2>> /var/lib/Pegasus/log/install.log || :;
      fi;
      /bin/systemctl try-restart tog-pegasus.service >/dev/null 2>&1 || :;
   fi;
fi
:;

%preun
%systemd_preun tog-pegasus.service
if [ $1 -eq 0 ]; then                  
   rm -rf /var/run/tog-pegasus
fi
:;

%postun
%systemd_postun_with_restart tog-pegasus.service

%preun devel
if [ $1 -eq 0 ] ; then
   make --directory %{_datadir}/Pegasus/samples -s clean >/dev/null 2>&1 || :;
fi
:;

%pre libs
if [ $1 -eq 1 ]; then
   {
      %sysusers_create_compat %{SOURCE8}
   } >/dev/null 2>&1 || :;
fi
:;

%post libs
if [ $1 -eq 1 ]; then
   ln -sf libpegclient.so.1 /usr/%PEGASUS_ARCH_LIB/libpegclient.so
   ln -sf libpegcommon.so.1 /usr/%PEGASUS_ARCH_LIB/libpegcommon.so
   ln -sf libpegprovider.so.1 /usr/%PEGASUS_ARCH_LIB/libpegprovider.so
   ln -sf libDefaultProviderManager.so.1 /usr/%PEGASUS_ARCH_LIB/libDefaultProviderManager.so
   ln -sf libCIMxmlIndicationHandler.so.1 /usr/%PEGASUS_ARCH_LIB/libCIMxmlIndicationHandler.so
   ln -sf libsnmpIndicationHandler.so.1 /usr/%PEGASUS_ARCH_LIB/libsnmpIndicationHandler.so

   ln -sf libComputerSystemProvider.so.1 /usr/%PEGASUS_ARCH_LIB/Pegasus/providers/libComputerSystemProvider.so
   ln -sf libOSProvider.so.1 /usr/%PEGASUS_ARCH_LIB/Pegasus/providers/libOSProvider.so
   ln -sf libProcessProvider.so.1 /usr/%PEGASUS_ARCH_LIB/Pegasus/providers/libProcessProvider.so

   ln -sf libCMPIProviderManager.so.1 /usr/%PEGASUS_ARCH_LIB/Pegasus/providerManagers/libCMPIProviderManager.so

   /bin/chgrp -h pegasus /usr/%{_lib}/libpegclient.so
   /bin/chgrp -h pegasus /usr/%{_lib}/libpegcommon.so 
   /bin/chgrp -h pegasus /usr/%{_lib}/libpegprovider.so
   /bin/chgrp -h pegasus /usr/%{_lib}/libDefaultProviderManager.so
   /bin/chgrp -h pegasus /usr/%{_lib}/libCIMxmlIndicationHandler.so
   /bin/chgrp -h pegasus /usr/%{_lib}/libsnmpIndicationHandler.so
   /bin/chgrp -h pegasus /usr/%{_lib}/Pegasus/providers/libComputerSystemProvider.so
   /bin/chgrp -h pegasus /usr/%{_lib}/Pegasus/providers/libOSProvider.so
   /bin/chgrp -h pegasus /usr/%{_lib}/Pegasus/providers/libProcessProvider.so
   /bin/chgrp -h pegasus /usr/%{_lib}/Pegasus/providerManagers/libCMPIProviderManager.so
fi
:;

%files
%license doc/license.txt
%doc doc/license.txt
%doc doc/Admin_Guide_Release.pdf
%doc doc/PegasusSSLGuidelines.htm
%doc OpenPegasusNOTICE.txt
%defattr(0640, root, pegasus, 0750)
%verify(not md5 size mtime mode group) /var/lib/Pegasus/repository
%defattr(0640, root, pegasus, 0750)
%dir /var/lib/Pegasus
/var/lib/Pegasus/cache
%dir /var/lib/Pegasus/log
%defattr(0640, root, pegasus, 0750)
%dir %{_sysconfdir}/Pegasus
%dir %{_sysconfdir}/pki/Pegasus
%{_tmpfilesdir}/tog-pegasus.conf
%defattr(0640, root, pegasus, 1750)
%ghost /var/run/tog-pegasus
%ghost %attr(0600, root, root) /var/run/tog-pegasus/cimserver.pid
%ghost %attr(0600, root, root) /var/run/tog-pegasus/cimserver_start.lock
%ghost %attr(0777 ,root, root) /var/run/tog-pegasus/cimxml.socket
%attr(0644, root, pegasus) %{_unitdir}/tog-pegasus.service
%defattr(0640, root, pegasus, 0750)
%ghost %attr(0644, root, root) %config(noreplace) %{_sysconfdir}/Pegasus/cimserver_current.conf
%ghost %attr(0644, root, root) %config(noreplace) %{_sysconfdir}/Pegasus/cimserver_planned.conf
%config(noreplace) %{_sysconfdir}/Pegasus/access.conf
%config(noreplace) %{_sysconfdir}/pam.d/wbem
%defattr(0444, root, root)
%ghost %{_sysconfdir}/pki/Pegasus/client.pem
%ghost %{_sysconfdir}/pki/Pegasus/server.pem
%defattr(0400, root, root)
%ghost %{_sysconfdir}/pki/Pegasus/file.pem
%defattr(0644, root, root)
%ghost %{_sysconfdir}/pki/Pegasus/ca.crt
%ghost %{_sysconfdir}/pki/Pegasus/ca.srl
%ghost %{_sysconfdir}/pki/Pegasus/client.srl
%defattr(0400, root, root)
%ghost %{_sysconfdir}/Pegasus/ssl-ca.cnf
%ghost %{_sysconfdir}/Pegasus/ssl-service.cnf
%defattr(0644, root, root)
%ghost %{_sysconfdir}/pki/ca-trust/source/anchors/localhost-pegasus.pem
%ghost %attr(0640, root, pegasus) %{_sysconfdir}/pki/Pegasus/cimserver_trust
%ghost %attr(0640, root, pegasus) %{_sysconfdir}/pki/Pegasus/indication_trust
%dir %attr(0640, root, pegasus) %{_sysconfdir}/pki/Pegasus/crl
%ghost %attr(0644, root, root) %verify(not md5 size mtime) /var/lib/Pegasus/log/install.log
%ghost %attr(0640, root, pegasus) %verify(not md5 size mtime) /var/lib/Pegasus/cache/trace/cimserver.trc
%defattr(0755, root, pegasus, 0755)
%{_sbindir}/*
%{_bindir}/*
%{_libexecdir}/pegasus/
%defattr(0644, root, pegasus, 0755)
%{_datadir}/Pegasus/mof
%dir %{_datadir}/Pegasus
%defattr(0755, root, pegasus, 0750)
%{_datadir}/Pegasus/scripts
%defattr(0644, root, pegasus, 0755)
%{_datadir}/man/man8/*
%{_datadir}/man/man1/*

%files devel
%defattr(0644,root,pegasus,0755)
%{_includedir}/Pegasus
%{_datadir}/Pegasus/samples
%{_datadir}/Pegasus/html

%files libs
%{_sysusersdir}/tog-pegasus.conf
%defattr(0755, root, pegasus, 0755)
%{_libdir}/*
%exclude /usr/lib/debug
%exclude /usr/lib/systemd
%exclude %{_tmpfilesdir}

%files test
%defattr(0644,root,pegasus,0755)
%dir %{_datadir}/Pegasus/test
%{_datadir}/Pegasus/test/Makefile
%attr(0600, root, root) %{_datadir}/Pegasus/test/snmptrapd.conf
%{_datadir}/Pegasus/test/mak
%dir %{_datadir}/Pegasus/test/tmp
%ghost %{_datadir}/Pegasus/test/tmp/procIdFile
%ghost %{_datadir}/Pegasus/test/tmp/trapLogFile
%ghost %{_datadir}/Pegasus/test/tmp/IndicationStressTestLog
%ghost %{_datadir}/Pegasus/test/tmp/oldIndicationStressTestLog
%verify(not md5 size mtime) /var/lib/Pegasus/testrepository
%defattr(0750,root,pegasus,0755)
%{_datadir}/Pegasus/test/bin
%{_datadir}/Pegasus/test/%PEGASUS_ARCH_LIB

%changelog
* Tue May 21 2024 Huang Yang <huangyang@loongson.cn> - 2.14.1-6
- [Type] other
- [DESC] add loongarch64 support

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.1-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue May 16 2023 Shuo Wang <abushwang@tencent.com> - 2.14.1-4
- add Conflicts to libcmpiCppImpl0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Mon Apr 03 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.1-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 22 2023 Shuo Wang <abushwang@tencent.com> - 2.14.1-1
- initial build
